/* 
 * Copyright (c) 1990,1991,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: cthreads.h 1.6 94/12/16$
 *	Author: University of Utah CSL
 */

#ifndef _MACHINE_CTHREADS_H_
#define _MACHINE_CTHREADS_H_

#define	STACK_GROWTH_UP	1

typedef struct { int _ldcws[4]; } spin_lock_t;

#define SPIN_LOCK_INITIALIZER { -1, -1, -1, -1 }

/*
 * we'll always assign a block of 16 bytes to the spinlock and then assume
 * that the real lock is the one aligned on a 16 byte boundary
 */
#define	_align_spin_lock(s) \
  ((int *)(((int) (s) + sizeof(spin_lock_t) - 1) & ~(sizeof(spin_lock_t) - 1)))

#if 1
/* XXX for debugging */
#define spin_lock_init(s) \
	((s)->_ldcws[0]=(s)->_ldcws[1]=(s)->_ldcws[2]=(s)->_ldcws[3] = -1)
#else
#define spin_lock_init(s) (*_align_spin_lock(s) = -1)
#endif
#define spin_lock_locked(s) (*_align_spin_lock(s) == 0)

#ifdef __GNUC__
#define cthread_sp() \
({ \
	register int _sp; \
	asm __volatile ("copy %%r30,%0" : "=r" (_sp) : ); \
	_sp; \
})
#endif

#endif _MACHINE_CTHREADS_H_
