/* 
 * Copyright (c) 1991,1994, The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Utah $Hdr: autoconf.c 1.4 92/01/30$
 * 	Author: Bob Wheeler, University of Utah CSL, 8/91
 *
 */

/*
 *	Autoconfigure devices
 */

#include <machine/pdc.h>

autoconf()
{
	printf("Starting I/O device configuration\n");

	/*
	 * scan the system memory bus and everything below it for devices
	 */
	smbscan();

	/*
	 * now that everything is configured, try and find a console
	 */
	cninit();

	/*
	 * dump the configuration information
	 */
	smbdisplay();

	printf("I/O device configuration completed\n");

	dump_spa();

#ifdef	KGDB
	/*
	 * test if kernel GDB needed
	 */
	kgdb_mux_init();
#endif	/* KGDB */
}

#define BT_HPA   PAGE0->mem_boot.pz_hpa
#define BT_LAYER PAGE0->mem_boot.pz_layers

static char boot_device[10];
static char dump_device[10];
char *root_name = boot_device;
char *dump_name = dump_device;

get_root_device()
{
	if (smblayer(BT_HPA, BT_LAYER, boot_device)) {
		printf("can't find root device\n");
		boot_device[0] = '\0';
	} else
		printf("root on %s\n", root_name);
}
