/* 
 * Copyright (c) 1991, 1994 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: device.h 1.2 91/09/25$
 *	Author: Bob Wheeler, University of Utah CSL
 */

/*
 *	Structures for device drivers and autoconfig
 */

/*
 * Each bus, controller and device has a driver structure that describes
 * what routines manuipulate the device.
 */
struct driver {
        char    *name;
        int     (*attach)();		/* initialize device */
        int     (*probe)();		/* probe for device */
        int     (*scan)();		/* scan for slaves */
        void    (*display)();		/* display configuration */
	int	(*layer)();		/* layer structure to name routine */
};

struct bus {
        struct driver   *driver;	/* routines for device or controller */
        int             unit;		/* unit of this device or controller */
	struct driver	*bustype;	/* type of bus this device is on */
	int		busunit;	/* unit of bus this device is on */
	int		busslot;	/* slot on bus this device is at */
	int		flags;		/* used by some attach routines */
};
