/*
 *  (c) Copyright 1992 HEWLETT-PACKARD COMPANY
 *
 *  To anyone who acknowledges that this file is provided "AS IS"
 *  without any express or implied warranty:
 *      permission to use, copy, modify, and distribute this file
 *  for any purpose is hereby granted without fee, provided that
 *  the above copyright notice and this notice appears in all
 *  copies, and that the name of Hewlett-Packard Company not be
 *  used in advertising or publicity pertaining to distribution
 *  of the software without specific, written prior permission.
 *  Hewlett-Packard Company makes no representations about the
 *  suitability of this software for any purpose.
 */
/*
 * (c) Copyright 1990, OPEN SOFTWARE FOUNDATION, INC.
 * ALL RIGHTS RESERVED
 */
/* 
 * Mach Operating System
 * Copyright (c) 1989 Carnegie-Mellon University
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 */

/*	5.2 SID scnhdr.h	2.2 12/15/82	*/

#ifndef _SCNHDR_H_
#define  _SCNHDR_H_

struct scnhdr {
#if defined(__hp_osf)
#	define s_name          _n._n_name
#	define s_zeroes        _n._n_n._n_zeroes
#	define s_offset        _n._n_n._n_offset
#	define s_nptr          _n._n_nptr[1]
	union section_name {
		char _n_name[8];   	/* Name lives here if 1-8 chars, */
		struct {
			long _n_zeroes; /* zero if > 8 chars */
			long _n_offset; /* offset into string table. */
		} _n_n;
		char *_n_nptr[2];	/* allows overlaying */
	} _n;
#else /* __hp_osf */
	char		s_name[8];	/* section name */
#endif /* !__hp_osf */
	long		s_paddr;	/* physical address */
	long		s_vaddr;	/* virtual address */
	long		s_size;		/* section size */
	long		s_scnptr;	/* file ptr to raw data for section */
	long		s_relptr;	/* file ptr to relocation */
	long		s_lnnoptr;	/* file ptr to line numbers */
	unsigned short	s_nreloc;	/* number of relocation entries */
	unsigned short	s_nlnno;	/* number of line number entries */
	long		s_flags;	/* flags */
#ifdef	ns32000
	long		s_symptr;	/* file pointer to symbol entries */
	unsigned short	s_modno;	/* Module number of module associated */
					/*   with this section */
	short		s_pad;		/* padding to 4 byte multiple */
#endif
	};

#define SCNHDR	struct scnhdr
#define SCNHSZ	sizeof(SCNHDR)

#if defined(i386) || defined(__hp_osf)
/*
 * The number of shared libraries in a .lib section in an absolute output file
 * is put in the s_paddr field of the .lib section header, the following
 * definition allows it to be referenced as s_nlib
 */
#define s_nlib	s_paddr
#endif	/* i386 or __hp_osf */


/*
 * Define constants for names of "special" sections
 */

#define _TEXT ".text"
#define _DATA ".data"
#define _BSS  ".bss"
#ifdef	ns32000
#define _SHRDATA  ".shrdata"
#define _SHRBSS  ".shrbss"
#endif
#define _TV  ".tv"
#ifdef i386
#define _INIT ".init"
#define _FINI ".fini"
#endif /* i386 */

#if defined(__hp_osf)
#	define _INIT ".init"
#	define _FINI ".fini"
#	define _SRI 	".sri"		/* Static Resource Information (systype, et al.) */
#	define _MIR 	".mir"		/* Module Information Records  */
#	define _APTV	".aptv"		/* Apollo-style transfer vectors. */
#	define _INLIB	".inlib"	/* Shared Library information */
#	define _RWDI	".rwdi"		/* Read/write data initialization directives for compressed sections */
#	define _UNWIND	".unwind"	/* Stack unwind information */
#endif	/* __hp_osf */


/*
 * The low 2 bytes of s_flags is used as a section "type"
 */

#define STYP_REG	0x00		/* "regular" section:
						allocated, relocated, loaded */
#define STYP_DSECT	0x01		/* "dummy" section:
						not allocated, relocated,
						not loaded */
#define STYP_NOLOAD	0x02		/* "noload" section:
						allocated, relocated,
						 not loaded */
#define STYP_GROUP	0x04		/* "grouped" section:
						formed of input sections */
#define STYP_PAD	0x08		/* "padding" section:
						not allocated, not relocated,
						 loaded */
#define STYP_COPY	0x10		/* "copy" section:
						for decision function used
						by field update;  not
						allocated, not relocated,
						loaded;  reloc & lineno
						entries processed normally */
#define STYP_TEXT	0x20		/* section contains text only */
#define STYP_DATA	0x40		/* section contains data only */
#define STYP_BSS	0x80		/* section contains bss only */
#ifdef i386
#define STYP_INFO	0x200		/* comment section : not allocated
						not relocated, not loaded */
#define STYP_LIB	0x800		/* for .lib section : same as INFO */
#define STYP_OVER	0x400		/* overlay section : relocated
						not allocated or loaded */
#endif /* i386 */

#if defined(__hp_osf)
/* the number of shared libraries in a .lib section in an absolute output file
 * is put in the s_paddr field of the .lib section header, the following define
 * allows it to be referenced as s_nlib
 */

#define s_nlib	s_paddr

#define STYP_INFO	0x200			/* comment section : not allocated 	 	*/
						/*	not relocated, not loaded 		*/
#define STYP_LIB	0x800			/* for .lib section : same as INFO 		*/
#define STYP_OVER	0x400			/* overlay section : relocated			*/
						/*	not allocated or loaded 		*/
#define STYP_RELOCATED_NOT_LOADED 0x00010000	/* Section is relocated normally during linking,*/
					   	/* 	but need not be loaded during program 	*/
					   	/* 	execution				*/
#define STYP_DEBUG              0x00020000	/* debug section 				*/
#define STYP_OVERLAY		0x00040000	/* Section is overlayed 			*/
#define STYP_INSTRUCTION    	0x00200000	/* Section contains executable code 		*/
#define STYP_GB_ADDRESSED	0x00400000	/* Section must be allocated in GB area 	*/
#define STYP_ZERO		0x00800000	/* Section is initialized to zero 		*/
#define STYP_INSTALLED		0x02000000	/* Section should be installable in KGT 	*/
#define STYP_LOOK_INSTALLED	0x04000000	/* Look for section in KGT 			*/
#define STYP_SECALIGN1		0x08000000	/* Section alignment requirements, as follows	*/
#define STYP_SECALIGN2		0x10000000	/*  align1  align2  actual-alignment         	*/
						/*   0       0     double word (32 bits)      	*/
						/*   0       1     quad word   (64 bits)      	*/
						/*   1       0     -undefined-                	*/
						/*   1       1     kbyte       (8192 bits)    	*/
#define STYP_COMPRESSED		0x20000000	/* No section data per se (s_scnptr = 0), 	*/
						/* 	but there are initialization directives	*/
						/*	for it in .rwdi section(used in 	*/
						/*	conjunction with STYP_BSS) 		*/

/*
 * Escape value for s_nreloc field of section header, indicating that the first
 * relocation entry for the section specifies the actual number of relocation
 * entries for the section.  This extension is required to support sections having
 * more than 65,535 relocation entries.
 */
#define S_NRELOC_ESC 	65535

#endif  /* __hp_osf */

#ifdef	ns32000
#define STYP_SHARE	0x400		/* shared section : relocated
						allocated and loaded
						not passed over fork() */
#endif

/*
 *  In a minimal file or an update file, a new function
 *  (as compared with a replaced function) is indicated by S_NEWFCN
 */

#if defined(i386) || defined(__hp_osf)
#define S_NEWFCN  0x100
#else	/* i386 or __hp_osf */
#define S_NEWFCN  0x10
#endif	/* i386 */

/*
 * In 3b Update Files (output of ogen), sections which appear in SHARED
 * segments of the Pfile will have the S_SHRSEG flag set by ogen, to inform
 * dufr that updating 1 copy of the proc. will update all process invocations.
 */

#define S_SHRSEG	0x20

#endif /* _SCNHDR_H_ */
