/*
 * Copyright (c) 1991,1992,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE. *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Utah $Hdr: crt0.s 1.11 94/12/16$
 */

/*
 * user startup routine
 */


#include <mach/machine/asm.h>

	.space	$TEXT$

	.subspa $UNWIND_START$,QUAD=0,ALIGN=8,ACCESS=0x2c,SORT=56
	.subspa	$CODE$

/*
 * $START$(argc, argv, envp)
 * 	int argc;
 * 	char **argv;
 * 	char **envp;
 *
 * Initial execution of a task. We assume that our parent set us up with
 * a valid stack to run on.
 */
	.proc
	.callinfo SAVE_SP,FRAME=128
	.export	$START$,entry
	.entry
$START$ 

	/*
	 * initialize the global data pointer dp
	 */
	ldil    L%$global$,dp
	ldo     R%$global$(dp),dp

	/*
	 * double word align the stack and allocate a stack frame to start out
	 * with.
	 */
	ldo     128(sp),sp
	depi    0,31,3,sp

	/* For _progname and $ARGV.  */
	ldw     0(arg1),r3             ;Get argv[0]...
	addil   L%$ARGV-$global$,dp
	stw     r3,R%$ARGV-$global$(r1)    ;  and stash it away

	/*
	 * Stash the args away in callee save registers.
	 */
	copy	arg0,r10
	copy	arg1,r11
	copy	arg2,r12
	copy	arg3,r13

	/*
	 * See if mach_init is defined. If so, call it to get MIG initialized
	 * for the task.
	 */
        .import mach_init_routine,data
	.import $$dyncall,millicode
        ldil    L%mach_init_routine,%r22
        ldw     R%mach_init_routine(%r22),%r22

        comb,=,n r0,t1,$no_minit

	.call
	bl $$dyncall,%r31
	copy %r31,%r2

$no_minit
	/*
	 * Call cthread_init, which initializes mutithreaded MiG and allocates
	 * the first cthread for the task. It then allocates a stack, stores
	 * the self reference pointer for us and returns the stack we should
	 * start with. This stack is not aligned and we need to double word
	 * align it before use. Most of the old stack has been deallocated. If
	 * the routine returns 0 for the stack then this is not the first task
	 * in the cthreads environment and we should stay on the current stack.
	 */
        .import _cthread_init_routine,data
        ldil    L%_cthread_init_routine,%r22
        ldw     R%_cthread_init_routine(%r22),%r22

        comb,=,n r0,t1,$no_cinit

	.call
	bl $$dyncall,%r31
	copy %r31,%r2

	comb,=,n r0,ret0,$no_cinit

	/*
	 * We have a new stack to switch to, align it to a double word boundary
	 * and allocate a stack frame.
	 */
	ldo	7(ret0),ret0
	depi	0,31,3,ret0

	copy	ret0,sp
	ldo	48(sp),sp

$no_cinit
	/*
	 * Okay, get ready to call main (finally). First we have to reload
	 * the argument registers.
	 */
        .import environ,data

	copy	r10,arg0
	copy	r11,arg1
	copy	r12,arg2
	copy	r13,arg3

	ldil    L%environ,t1
	stw     arg2,R%environ(t1)

	.import main,code
	ldil	L%main,%r22
	ldo	R%main(%r22),%r22

	.call
	bl $$dyncall,%r31
	copy %r31,%r2

	/*
	 * see if the routine pointed to by (_cthread_exit_routine)() is not 
	 * NULL, if so then execute it. Normally it points to cthread_exit().
	 * Pass it return value from main.
	 */
	.import _cthread_exit_routine,data
	ldil    L%_cthread_exit_routine,%r22
	ldw     R%_cthread_exit_routine(%r22),%r22

	comb,=,n r0,t1,$no_cexit

	copy	ret0,arg0

	.call
	bl $$dyncall,%r31
	copy %r31,%r2

	/*
	 * never returns...
	 */
	break	0,0

$no_cexit
	/*
	 * call exit() directly with the return status from main.
	 */
	.import exit,code
	ldil	L%exit,%r22
	ldo	R%exit(%r22),%r22

	copy	ret0,arg0

	.call
	bl $$dyncall,%r31
	copy %r31,%r2

	/*
	 * never returns
	 */
	break	0,0

	.exit
	.procend

	.subspa $UNWIND_START$
	.export $UNWIND_START,data
$UNWIND_START
	.subspa	$UNWIND_END$,QUAD=0,ALIGN=8,ACCESS=0x2c,SORT=72
	.export	$UNWIND_END,data
$UNWIND_END

	.subspa	$RECOVER_START$,QUAD=0,ALIGN=4,ACCESS=0x2c,SORT=73
	.export $RECOVER_START,data
$RECOVER_START
	.subspa	$RECOVER$MILLICODE$,QUAD=0,ALIGN=4,ACCESS=0x2c,SORT=78
	.subspa	$RECOVER$
	.subspa	$RECOVER_END$,QUAD=0,ALIGN=4,ACCESS=0x2c,SORT=88
	.export	$RECOVER_END,data
$RECOVER_END

	.space	$PRIVATE$
        .SUBSPA $DATA$

mach_init_routine	.comm 8
_cthread_init_routine	.comm 8
_cthread_exit_routine	.comm 8
environ			.comm 8

__progname:
$ARGV:	.word    0
        .export __progname,data
        .export $ARGV,data


	.subspa	$GLOBAL$
	.export	$global$,data
$global$

	.end
